[![Python versions on PyPI](https://img.shields.io/pypi/pyversions/centrex-tlf.svg)](https://pypi.python.org/pypi/centrex-tlf/)
[![CeNTREX-TlF version on PyPI](https://img.shields.io/pypi/v/centrex-tlf.svg "CeNTREX-TlF on PyPI")](https://pypi.python.org/pypi/centrex-tlf/)
[![Code style: black](https://img.shields.io/badge/code%20style-black-000000.svg)](https://github.com/psf/black)

## Extensions
[![CeNTREX-TlF-julia-extension version on PyPI](https://img.shields.io/badge/extension-julia-informational "CeNTREX-TlF-julia-extension on PyPI")](https://github.com/ograsdijk/CeNTREX-TlF-julia-extension) [![CeNTREX-TlF version on PyPI](https://img.shields.io/pypi/v/centrex-tlf-julia-extension.svg "CeNTREX-TlF on PyPI")](https://pypi.python.org/pypi/centrex-tlf-julia-extension/)
# CeNTREX-TlF
Code for generating the CeNTREX TlF States, Hamiltonians, Transitions, Couplings and Lindblad equations.

Consists of six modules:
* `states`
* `hamiltonian`
* `transitions`
* `couplings`
* `lindblad`
* `utils`

`states` has code to generate states and the classes that describe the `CoupledBasisState`, `UncoupledBasisState` and `State`; where `State` holds multiple `CoupledBasisStates` or `UncoupledBasisStates` with different amplitudes, i.e. when superpositions arise.

## Dependencies
* `numpy`
* `scipy`
* `sympy`
* `pandas`
  
## Installation
`python -m pip install .`  
where `.` is the path to the directory. To install directly from `Github` use:  
`python -m pip install git+https://github.com/ograsdijk/CeNTREX-TlF`

# `states`
`states` contains the functions and classes to represent the TlF states:  
`CoupledBasisState` is a class representing a TlF state with coupled quantum numbers, i.e. F, mF, F1, J, I1, I2, Ω, P.  
`UncoupledBasisState` is a class representing a TlF state with uncoupled quantum numbers, i.e. J, mJ, I1, m1, I2, m2, Ω, P.  
Finally `State` is a class representing a collection of states, since in most cases the TlF molecules are in a superposition state.

```Python
from centrex_tlf import states
states.CoupledBasisState(F=1, mF=0, F1 = 1/2, J = 0, I1 = 1/2, I2 = 1/2, Omega = 0, P = 1)
```
or using some of the functions to generate all hyperfine substates in a given J level: 
```Python
from centrex_tlf import states
QN = states.generate_uncoupled_states_ground(Js = [0,1])
```
which returns an array containing the UncoupledBasisStates
```python
array([|X, J = 0, mJ = 0, I₁ = 1/2, m₁ = -1/2, I₂ = 1/2, m₂ = -1/2, P = +, Ω = 0>,
       |X, J = 0, mJ = 0, I₁ = 1/2, m₁ = -1/2, I₂ = 1/2, m₂ = 1/2, P = +, Ω = 0>,
       |X, J = 0, mJ = 0, I₁ = 1/2, m₁ = 1/2, I₂ = 1/2, m₂ = -1/2, P = +, Ω = 0>,
       |X, J = 0, mJ = 0, I₁ = 1/2, m₁ = 1/2, I₂ = 1/2, m₂ = 1/2, P = +, Ω = 0>,
       |X, J = 1, mJ = -1, I₁ = 1/2, m₁ = -1/2, I₂ = 1/2, m₂ = -1/2, P = -, Ω = 0>,
       |X, J = 1, mJ = -1, I₁ = 1/2, m₁ = -1/2, I₂ = 1/2, m₂ = 1/2, P = -, Ω = 0>,
       |X, J = 1, mJ = -1, I₁ = 1/2, m₁ = 1/2, I₂ = 1/2, m₂ = -1/2, P = -, Ω = 0>,
       |X, J = 1, mJ = -1, I₁ = 1/2, m₁ = 1/2, I₂ = 1/2, m₂ = 1/2, P = -, Ω = 0>,
       |X, J = 1, mJ = 0, I₁ = 1/2, m₁ = -1/2, I₂ = 1/2, m₂ = -1/2, P = -, Ω = 0>,
       |X, J = 1, mJ = 0, I₁ = 1/2, m₁ = -1/2, I₂ = 1/2, m₂ = 1/2, P = -, Ω = 0>,
       |X, J = 1, mJ = 0, I₁ = 1/2, m₁ = 1/2, I₂ = 1/2, m₂ = -1/2, P = -, Ω = 0>,
       |X, J = 1, mJ = 0, I₁ = 1/2, m₁ = 1/2, I₂ = 1/2, m₂ = 1/2, P = -, Ω = 0>,
       |X, J = 1, mJ = 1, I₁ = 1/2, m₁ = -1/2, I₂ = 1/2, m₂ = -1/2, P = -, Ω = 0>,
       |X, J = 1, mJ = 1, I₁ = 1/2, m₁ = -1/2, I₂ = 1/2, m₂ = 1/2, P = -, Ω = 0>,
       |X, J = 1, mJ = 1, I₁ = 1/2, m₁ = 1/2, I₂ = 1/2, m₂ = -1/2, P = -, Ω = 0>,
       |X, J = 1, mJ = 1, I₁ = 1/2, m₁ = 1/2, I₂ = 1/2, m₂ = 1/2, P = -, Ω = 0>],
      dtype=object)
```
State objects, which are superpositions of BasisStates are also generated easily:
```Python
superposition = 1*QN[0] + 0.1j*QN[1]
```
which returns
```Python
1.00 x |X, J = 0, mJ = 0, I₁ = 1/2, m₁ = -1/2, I₂ = 1/2, m₂ = -1/2, P = +, Ω = 0>
0.00+0.10j x |X, J = 0, mJ = 0, I₁ = 1/2, m₁ = -1/2, I₂ = 1/2, m₂ = 1/2, P = +, Ω = 0>
```
A subset of `State`, `CoupledBasisStates` can be selected with the `QuantumSelector` as follows:
```Python
QN = states.generate_coupled_states_ground(Js = [0,1])
qn_select = states.QuantumSelector(J = 1, mF = 0, electronic = states.ElectronicState.X)
qn_select.get_indices(QN)
```
which returns all the indices with `J=1` and `mJ=0`:
```python
array([ 4,  6,  9, 13], dtype=int64)
```
# `hamiltonian`
`hamiltonian` contains the functions to generate TlF hamiltonians in the X and B state in either coupled or uncoupled form.  
Generating a ground state X hamiltonian can be accomplished easily using some convenience functions:
```Python
from centrex_tlf import states, hamiltonian

# generate the hyperfine sublevels in J=0 and J=1
QN = states.generate_uncoupled_states_ground(Js = [0,1])

# generate a dictionary with X hamiltonian terms
H = hamiltonian.generate_uncoupled_hamiltonian_X(QN)

# create a function outputting the hamiltonian as a function of E and B
Hfunc = hamiltonian.generate_uncoupled_hamiltonian_X_function(H)
```
All functions generating hamiltonians only require a list or array of TlF states. Generating the hamiltonian only for certain hyperfine sublevels is hence also straightforward. The function `calculate_uncoupled_hamiltonian_X` calculates the hamiltonians from scratch, whereas `generate_uncoupled_hamiltonian_X` pulls the non-zero elements from an sqlite database.

To convert a hamiltonian from one basis to another transformation matrices can be generated or calculated
(`generate_transform_matrix` pulls non-zero matrix elements from an sqlite database, `calculate_transform_matrix` does the full element wise calculation):
```Python
from centrex_tlf import states, hamiltonian

# generate the hyperfine sublevels in J=0 and J=1
QN = states.generate_uncoupled_states_ground(Js = [0,1])
# generate the coupled hyperfine sublevels in J=0 and J=1
QNc = states.generate_coupled_states_ground(Js = [0,1])

# generate a dictionary with X hamiltonian terms
H = hamiltonian.generate_uncoupled_hamiltonian_X(QN)
Hfunc = hamiltonian.generate_uncoupled_hamiltonian_X_function(H)
H0 = Hfunc(E = [0,0,0], B = [0,0,1e-3])

# generate the transformation matrix
transform = hamiltonian.generate_transform_matrix(QN, QNc)

# calculate the transformed matrix
H0c = transform.conj().T@H0@transform
```
This is mostly used for optical bloch simulations where the coupled states representation is more convenient.

## Stark Shift Example
To calculate the energy levels as a function of the electric field the following code can be used, which calculates all energies up to `J=6` but only plots the `|J=2, mJ=0>` hyperfine levels. These are the states focussed by the electrostatic quadrupole lens in the CeNTREX experiment.
![Quadrupole Lens States](quadrupole_lens_states.png)
```Python
import numpy as np
import matplotlib.pyplot as plt

from centrex_tlf import states, hamiltonian

# generate states up to J=6
QN = states.generate_uncoupled_states_ground(Js=np.arange(7))

# generate the X hamiltonian terms
H = hamiltonian.generate_uncoupled_hamiltonian_X(QN)

# create a function outputting the hamiltonian as a function of E and B
Hfunc = hamiltonian.generate_uncoupled_hamiltonian_X_function(H)

# V/cm
Ez = np.linspace(0, 50e3, 101)

# generate the Hamiltonian for (almost) zero field, add a small field to make states
# non-degenerate
Hi = Hfunc(E=[0, 0, 1e-3], B=[0, 0, 1e-3])
E, V = np.linalg.eigh(Hi)

# get the true superposition-states of the system
QN_states = hamiltonian.matrix_to_states(V, QN)

# original eigenvectors used in tracking states as energies change order
V_track = V.copy()

# indices of the J=2, mJ=0 states focused by the lens
indices_J2_mJ0 = [
    idx
    for idx, s in enumerate(QN_states)
    if s.largest.J == 2 and s.largest.mJ == 0
]

indices_J012 = [
    idx for idx, s in enumerate(QN_states) if s.largest.J in [0, 1, 2]
]

# empty array for storing energies
energy = np.empty([Ez.size, len(QN)], dtype=np.complex128)

# iterate over the electric field values
for idx, Ei in enumerate(Ez):
    Hi = Hfunc(E=[0, 0, Ei], B=[0, 0, 1e-3])
    E, V = np.linalg.eigh(Hi)

    # sort indices to keep the state order the same
    indices = np.argmax(np.abs(V_track.conj().T @ V), axis=1)
    energy[idx, :] = E[indices]
    V_track[:, :] = V[:, indices]

# plot the J=2, mJ=0 Stark curves
fig, ax = plt.subplots(figsize=(12, 8))
ax.plot(
    Ez,
    (energy.real[:, indices_J2_mJ0] - energy.real[:, indices_J2_mJ0][0, 0])
    / (2 * np.pi * 1e9),
)
ax.set_xlabel("E [V/cm]")
ax.set_ylabel("Energy [GHz]")
ax.set_title("|J=2, mJ=0> Stark Curve")
ax.grid(True)
plt.show()
```

# `couplings`
Code for generating the CeNTREX TlF couplings. 
Includes code for generating branching ratios, electric dipole coupling elements and coupling fields

## Generating branching ratios
The code below generates branching ratios from `|J'=1, F1'=1/2, mF=0>` to all states in the `J=1` manifold.
```Python
from centrex_tlf import states, couplings

excited_state = states.CoupledBasisState(
    J=1, F1=1 / 2, F=1, mF=0, I1=1 / 2, I2=1 / 2, Omega=1, P=1
)
qn_select = states.QuantumSelector(J=1)
ground_states = [1*s for s in states.generate_coupled_states_X(qn_select)]
br = couplings.calculate_br(1 * excited_state, ground_states)
```

## Generating couplings
The code below generates the coupling fields for the `J=1` manifold to the `J'=1, F1'=1/2, F'=1` manifold. The returned value is a dataclass `CouplingFields` containing the following fields:  
* `ground_main`
* `excited_main`
* `main_coupling`: the electric dipole coupling between `ground_main` and `excited_main`
* `ground_states`: list of all ground states
* `excited_states`: list of all excited states
* `fields`: a list of `CouplingField` dataclasses with the following fields:  
  * `polarization`: polarization vector
  * `field`: coupling field in the `ground_states` + `excited_states` basis

```Python
from centrex_tlf import states, couplings

qn_select = states.QuantumSelector(J=1)
ground_states = states.generate_coupled_states_X(qn_select)

qn_select = states.QuantumSelector(J=1, F1=1 / 2, F=1, P=1, Ω=1)
excited_states = states.generate_coupled_states_B(qn_select)

# the generate_coupling_field_* functions requires lists as inputs, not np.ndarrays
QN = list(1 * np.append(ground_states, excited_states))
ground_states = [1*s for s in  ground_states]
excited_states = [1*s for s in excited_states]

H_rot = np.eye(len(QN), dtype=complex) * np.arange(len(QN))
V_ref = np.eye(len(QN))
pol_vecs = [np.array([0.0, 0.0, 1.0]), np.array([1.0, 0.0, 0.0])]
normalize_pol = True

coupling = couplings.generate_coupling_field_automatic(
    ground_states_approx = ground_states, 
    excited_states_approx = excited_states, 
    QN_basis = QN,
    H_rot = H_rot, 
    QN = QN, 
    V_ref = V_ref, 
    pol_vecs = pol_vecs, 
    normalize_pol = normalize_pol
)
```

using LinearAlgebra

@inline function zero_matrix!(M)
    n, m = size(M)
    T = eltype(M)
    z = zero(T)
    @inbounds begin
        for i in 1:n
            @simd for j in 1:m
                M[i, j] = z
            end
        end
    end
    return nothing
end

function commutator!(C, H, ρ)
    n = size(H, 1)

    @inbounds begin
        # zero out C
        zero_matrix!(C)

        T = eltype(H)
        z = zero(T)

        # compute upper triangle of -im*[H,ρ] and conjugate mirror
        for i in 1:n
            for j in i:n
                s = z
                @simd for k in 1:n
                    s += H[i, k]*ρ[k, j] - ρ[i, k]*H[k, j]
                end
                val = -im * s
                C[i, j] = val
                if i != j
                    C[j, i] = conj(val)
                end
            end
        end
    end

    nothing
end

function commutator_mat!(C, A, B)
    @inbounds begin
        mul!(C, B, A)
        mul!(C, A, B, -1im, 1im)
    end
    return nothing
end

function commutator_mat!(C, A, B, buf)
    @inbounds begin
        mul!(C, A, B)
        mul!(buf, B, A)
        C .-= buf
        C .*= -im
    end
    return nothing
end

@inline function gaussian_peak(x::T, μ::T=zero(T), σ::T=one(T)) where {T<:AbstractFloat}
    Δ = x - μ
    return exp(-T(0.5) * (Δ / σ)^2)
end

@inline function apply_transform!(out, in, transform, buffer)
    @inbounds begin
        # buf = in * T
        mul!(buffer, in, transform)
        # out = T' * buf   (T' is adjoint(T), no allocation)
        mul!(out, adjoint(transform), buffer)
    end
    nothing
end

function transform_couplings!(out, in, v0, v1, buffer)
    @inbounds begin
        # buf = in * v0
        mul!(buffer, in, v0)
        # out = v1' * buf   (v1' is adjoint(v1), no allocation)
        mul!(out, adjoint(v1), buffer)
    end
    nothing
end

using LinearAlgebra
using Plots
using ProgressMeter

include("electric_field.jl")
include("J01_J12_spa_functions.jl")
include("julia_functions.jl")

# field_path = "c:/Users/Olivier/Anaconda3/envs/centrex-eql-testing/Lib/site-packages/state_prep/electric_fields/Electric field components vs z-position_SPA_ExpeVer.csv"
field_path = "C:/Users/ogras/Documents/GitHub/centrex-state-prep/src/state_prep/electric_fields/Electric field components vs z-position_SPA_ExpeVer.csv"
# field_path = "c:/Users/ogras/anaconda3/envs/centrex-eql/Lib/site-packages/state_prep/electric_fields/Electric field components vs z-position_SPA_ExpeVer.csv"

function reorder_evecs!(
    V_out::AbstractMatrix{<:ComplexF64},
    E_out::AbstractVector{<:Real},
    V_in ::AbstractMatrix{<:ComplexF64},
    E_in ::AbstractVector{<:Real},
    V_ref::AbstractMatrix{<:ComplexF64},
    overlap::AbstractMatrix{<:Real},
    workspace_complex::AbstractMatrix{<:ComplexF64},
)
    # 1. Absolute overlap between every eigenvector in V_in and every reference vector
    mul!(workspace_complex, V_in', V_ref)
    overlap .= abs.(workspace_complex)

    # 2. For each eigenvector (row), find the reference column with maximum overlap
    best_ref = map(argmax, eachrow(overlap))     # vector length n_in

    # 3. Sort eigenvectors by that reference-column index
    perm     = sortperm(best_ref)                # matches Python np.argsort(…)

    # if any(perm .!= eachindex(perm))
    #     println("Re-ordering eigenvectors with permutation: ", perm)
    # end

    # 4. Reorder into the provided output buffers (buffers must be distinct from inputs)
    V_out .= @view V_in[:, perm]
    E_out .= @view E_in[perm]
    return nothing
end

@inline function calculate_probabilities!(
    out::AbstractMatrix,            # ntrack × N
    ψ::AbstractMatrix,             # N × ntrack
    ϕ::AbstractMatrix,             # N × N
    buf::AbstractMatrix)           # ntrack × N
    # buf = ψ' * ϕ   →  (ntrack × N)
    mul!(buf, ψ', ϕ)

    # element-wise |·|², in place
    @. out = abs2(buf)
    return nothing
end


function evolve(p, t_array, states_track, Ez_interp, N)
    nt      = length(t_array)
    ntrack  = length(states_track)

    # ─────────────────────────────────  helpers ─────────────────────────────────
    similar_c() = zeros(ComplexF64, N, N)         # N×N Complex work matrix
    similar_r() = zeros(Float64,   N, N)          # N×N real work matrix

    # ────────────────────────────  work buffers  ───────────────────────────────
    Hinit   = similar_c()
    H       = similar_c()
    buffer_c  = similar_c()
    buffer_r = similar_r()         # real scratch for reorder_evecs!
    Hrot    = similar_c()
    C       = similar_c()
    V       = similar_c()
    Vsort   = similar_c()
    Vref    = similar_c()
    Vrefinit= similar_c()
    U       = similar_c()          # N×N time-evolution operator

    tmp_NN  = similar_c()          # general N×N scratch
    tmp_Nk  = zeros(ComplexF64, ntrack, N)   # ntrack×N scratch
    phase_vec = zeros(ComplexF64, N)
    Phase     = Diagonal(phase_vec)

    Esort   = zeros(Float64, N)    # eigenvalues after re-order

    ψ       = zeros(ComplexF64, N, ntrack)   # current kets
    ψ_tmp   = similar(ψ)                      # scratch for ψ update

    # ───────────────────────────  result containers  ───────────────────────────
    ψt  = Array{ComplexF64,3}(undef, N, ntrack, nt)
    Et  = Array{Float64,   2}(undef, N, nt)
    Pt  = Array{Float64,   3}(undef, ntrack, N, nt)

    # ───────────────────────────  initial step (t₀)  ───────────────────────────
    Ω0, Ω1, ω0, ω1, δ0, δ1, vz, z0 = p

    Ez   = Ez_interp(z0 + vz*t_array[1])
    hamiltonian_full_nocoupling!(Hinit, Ez)

    copyto!(buffer_c, Hinit)
    Eref, _ = LAPACK.syev!('V','U', buffer_c)     # eigen-pairs in   buffer / Eref
    copyto!(Vref, buffer_c)
    copyto!(Vrefinit, buffer_c)                   # keep a pristine copy if needed

    ψ .= @view Vref[:, states_track]

    ψt[:,:,1] .= ψ
    Et[:, 1]  .= Eref
    calculate_probabilities!(view(Pt,:,:,1), ψ, Vref, tmp_Nk)

    @inbounds for i in 2:length(t_array)
        dt = t_array[i] - t_array[i-1]
        t = t_array[i]

        z = z0 + vz * t
        Ez = Ez_interp(z)

        hamiltonian_full_nocoupling!(H, Ez)

        copyto!(V, H)
        D, _ = LinearAlgebra.LAPACK.syev!('V', 'U', V)
        # now V contains the eigenvectors

        reorder_evecs!(Vsort, Esort, V, D, Vref, buffer_r, buffer_c)

        Ωval0 = Ω0/2 * gaussian_peak(z, zμ0, σμ)
        Ωval1 = Ω1/2 * gaussian_peak(z, zμ1, σμ)
        coupling_full!(C, Ωval0, Ωval1)
        H .+= C
        apply_transform!(Hrot, H, V, buffer_c)
        detuning!(Hrot, δ0, δ1, ω0, ω1)

        Drot, _ = LinearAlgebra.LAPACK.syev!('V', 'U', Hrot)

        # Hrot now contains the eigenvectors

        # ── 1.  A ← Vview · Vrot  (unchanged) ──────────────────────────────
        mul!(U, V, Hrot)                     # U ≡ A   (N×N)

        # ── 2.  tmp_NN ← A · diag(phase)  (no copy of A) ───────────────────
        @inbounds @simd for k = 1:N              # build phase_vec in place
            θ = -Drot[k] * dt
            phase_vec[k] = ComplexF64(cos(θ), sin(θ))
        end
        mul!(tmp_NN, U, Phase)                   # tmp_NN = A_phase  (N×N)

        # ── 3.  buffer ← A_phase · A′  (identical to original) ─────────────
        mul!(buffer_c, tmp_NN, U')                # buffer = Udt

        # ── 4.  ψ ← Udt · ψ  (unchanged) ───────────────────────────────────
        mul!(ψ_tmp, buffer_c, ψ)
        ψ, ψ_tmp = ψ_tmp, ψ

        ψt[:, :, i] .= ψ
        Et[:, i] .= Esort
        calculate_probabilities!(@view(Pt[:, :, i]), ψ, Vsort, tmp_Nk)

        copyto!(Vref, Vsort)
    end
    return ψt, Et, Pt
end

const Ez_interp = make_Ez_interp(field_path)

const σμ = 1.078e-2
const zμ0 = 0.0
const zμ1 = 25.4e-3 * 1.125
const Γ = 2π * 1.56e6

Ω0 = 3e-1 * Γ
Ω1 = 2e-1 * Γ
ω0 = 83817989701.69382
ω1 = 167564827658.9896
δ0 = 0.0
δ1 = 0.0
vz = 184
z0 = -0.25
zstop = 0.2
tmax = (zstop - z0) / vz
N = 64
t_array = LinRange(0.0, tmax, 6001)
states_track = [1]

p = (Ω0, Ω1, ω0, ω1, δ0, δ1, vz, z0)

ψt, Et, Pt = evolve(p, t_array, states_track, Ez_interp, N);

@time ψt, Et, Pt = evolve(p, t_array, states_track, Ez_interp, N);

plot(t_array*vz .+ z0, Pt[1,1:36,:]')

argmax(Pt[1,:,1]), argmax(Pt[1,:,end])

using CSV
using DataFrames
using Interpolations

function make_Ez_interp(path::AbstractString)
    # 1) load data
    df = CSV.read(path, DataFrame)

    # 2) extract & convert with floating‐point division
    x = df[!, "Distance-250mm [mm]"] ./ 1000.0   # mm → m
    y = df[!, "Ez []"] ./ 100.0     # raw → your unit

    # 3) sanity‐checks for uniform spacing
    @assert length(x) ≥ 2 "Need at least two points for interpolation"
    Δx = x[2] - x[1]
    @assert Δx != 0 "Δx is zero—did you accidentally use .÷ instead of ./?"
    @assert all(abs.(diff(x) .- Δx) .< 1e-8) "x must be uniformly spaced"

    # 4) build & scale a cubic B-spline
    itp = interpolate(y, BSpline(Cubic(Line(OnGrid()))))
    sitp = scale(itp, x[1]:Δx:x[end])

    # 5) wrap to fill with 0.0 outside the domain
    return extrapolate(sitp, 0.0)
end

using SIMD
using LinearAlgebra
using LinearAlgebra.BLAS
using LinearAlgebra:copytri!
using DifferentialEquations
using CSV
using DataFrames
using Interpolations
using MKL

include("julia_functions.jl")
include("hamiltonian_nocoupling.jl")
include("couplings.jl")

efield_path = "c:/Users/Olivier/Anaconda3/envs/centrex-eql-testing/Lib/site-packages/state_prep/electric_fields/Electric field components vs z-position_SPA_ExpeVer.csv"
# efield_path = "c:/Users/ogras/anaconda3/envs/centrex-eql/Lib/site-packages/state_prep/electric_fields/Electric field components vs z-position_SPA_ExpeVer.csv"

const σμ = 1.078e-2
const zμ0 = 0.0
const zμ1 = 25.4e-3 * 1.125

function make_Ez_interp(path::AbstractString)
    # 1) load data
    df = CSV.read(path, DataFrame)

    # 2) extract & convert with floating‐point division
    x = df[!, "Distance-250mm [mm]"] ./ 1000.0   # mm → m
    y = df[!, "Ez []"] ./ 100.0     # raw → your unit

    # 3) sanity‐checks for uniform spacing
    @assert length(x) ≥ 2 "Need at least two points for interpolation"
    Δx = x[2] - x[1]
    @assert Δx != 0 "Δx is zero—did you accidentally use .÷ instead of ./?"
    @assert all(abs.(diff(x) .- Δx) .< 1e-8) "x must be uniformly spaced"

    # 4) build & scale a cubic B-spline
    itp = interpolate(y, BSpline(Cubic(Line(OnGrid()))))
    sitp = scale(itp, x[1]:Δx:x[end])

    # 5) wrap to fill with 0.0 outside the domain
    return extrapolate(sitp, 0.0)
end

const Ez_interp = make_Ez_interp(efield_path)

Γ = 2π*1.56e6
Ω0 = 0.05*Γ
δ0 = 2π*5.26e6
vz = 184
z0 = -0.25
zstop = 0.2
tmax = (zstop - z0) / vz
N = 16
diag_idxs = [i + (i - 1) * N for i in 1:N]

u0 = zeros(ComplexF64, N, N)
u0[2,2] = 1.0 + 0.0im

const utransformed = zeros(ComplexF64, 16, 16)
const dutransformed = zeros(ComplexF64, 16, 16)
const ω0 = 83784583915.18878
const V = zeros(ComplexF64, size(u0))
const C = zeros(ComplexF64, size(u0))
const Hrot = zeros(ComplexF64, size(u0))

const H = zeros(ComplexF64, size(u0))
const Hblock_J0 = @view H[1:4, 1:4]
const Hblock_J1 = @view H[5:16, 5:16]
const buffer = zeros(ComplexF64, size(u0))

const evals4 = zeros(ComplexF64, 4)
const evals12 = zeros(ComplexF64, 12)

const blk1 = Matrix{ComplexF64}(undef, 4, 4)   # contiguous
const blk2 = Matrix{ComplexF64}(undef, 12, 12)

const Vblk4  = @view V[1:4, 1:4]
const Vblk12 = @view V[5:16,5:16]

const diag_J0 = diagind(Hrot, 0)[1:4]
const Hrot_J0  = @view Hrot[diag_J0]
const diag_J1 = diagind(Hrot, 0)[5:16]
const Hrot_J1 = @view Hrot[diag_J1]

function hamiltonian_rotated!(Hrot, V, C, buffer, δ0)
    shift = ω0 + δ0

    @inbounds begin
        # copyto!(blk1, Hblock_J0)
        # copyto!(blk2, Hblock_J1)
        F0 = eigen(Hblock_J0)
        F1 = eigen(Hblock_J1)

        copyto!(Vblk4,  F0.vectors)
        copyto!(Vblk12, F1.vectors)

        mul!(buffer, C, V)
        # (adjoint(transform), no allocation)
        mul!(Hrot, adjoint(V), buffer)

        copyto!(Hrot_J0, F0.values)
        copyto!(Hrot_J1, F1.values)

        Hrot_J1 .-= shift
    end
    nothing
end

function lindblad!(du, u, p, t)
    Ω0, δ0, vz, z0 = p

    z = vz * t + z0

    Ez = Ez_interp(z0 + vz * t)

    Ω0val = Ω0*gaussian_peak(z, zμ0, σμ)
    hamiltonian_nocoupling!(H, Ez)
    couplings!(C, Ω0val)

    hamiltonian_rotated!(Hrot, V, C, buffer, δ0)

    mul!(buffer, u, V)
    mul!(utransformed, adjoint(V), buffer)

    commutator_mat!(dutransformed, Hrot, utransformed, buffer)

    mul!(buffer, dutransformed, adjoint(V))
    mul!(du, V, buffer)
    nothing
end


# p = (Ω0, Ω1, δ0, δ1, vz, z0)
p = (Ω0, δ0, vz, z0);
prob = ODEProblem(
    lindblad!,
    u0,
    (0.0, tmax),
    p,
);

@time sol = solve(prob, Tsit5(), save_idxs=diag_idxs, saveat=5e-6);

pop = hcat(real(sol.u)...);

# function prob_func(prob, i, repeat)
#     p = (rabis[i], δ0, vz, z0)
#     remake(prob, p=p)
# end

# function prob_func(prob, i, repeat)
#     p = (Ω0, detunings[i], vz, z0)
#     remake(prob, p=p)
# end

# detunings = (-6:0.25:10.0) .+ 5.25
# detunings *= 2π*1e6

# ens_prob = EnsembleProblem(prob, prob_func=prob_func);
# @time sol = solve(
#     ens_prob,
#     Tsit5(),
#     EnsembleSerial(),
#     trajectories=length(detunings),
#     save_idxs=diag_idxs,
#     save_start=false,
#     save_everystep=false,
# );

# pop = hcat([real(sol[i].u[1]) for i in 1:length(sol)]...);

using LinearAlgebra
using MKL
using Plots

include("electric_field.jl")
include("couplings.jl")
include("hamiltonian_nocoupling.jl")
include("julia_functions.jl")

# field_path = "c:/Users/Olivier/Anaconda3/envs/centrex-eql-testing/Lib/site-packages/state_prep/electric_fields/Electric field components vs z-position_SPA_ExpeVer.csv"
field_path = "c:/Users/ogras/anaconda3/envs/centrex-eql/Lib/site-packages/state_prep/electric_fields/Electric field components vs z-position_SPA_ExpeVer.csv"

function reorder_evecs!(
    V_out::AbstractMatrix{<:ComplexF64},
    E_out::AbstractVector{<:Real},
    V_in ::AbstractMatrix{<:ComplexF64},
    E_in ::AbstractVector{<:Real},
    V_ref::AbstractMatrix{<:ComplexF64},
)
    # 1. Absolute overlap between every eigenvector in V_in and every reference vector
    overlap  = abs.(V_in' * V_ref)               # size (n_in × n_ref)

    # 2. For each eigenvector (row), find the reference column with maximum overlap
    best_ref = map(argmax, eachrow(overlap))     # vector length n_in

    # 3. Sort eigenvectors by that reference-column index
    perm     = sortperm(best_ref)                # matches Python np.argsort(…)

    # if any(perm .!= eachindex(perm))
    #     println("Re-ordering eigenvectors with permutation: ", perm)
    # end

    # 4. Reorder into the provided output buffers (buffers must be distinct from inputs)
    V_out .= @view V_in[:, perm]
    E_out .= @view E_in[perm]
    return nothing
end

@inline function calculate_probabilities!(out::AbstractMatrix,            # ntrack × N
    ψ::AbstractMatrix,             # N × ntrack
    ϕ::AbstractMatrix,             # N × N
    buf::AbstractMatrix)           # ntrack × N
    # buf = ψ' * ϕ   →  (ntrack × N)
    mul!(buf, ψ', ϕ)

    # element-wise |·|², in place
    @. out = abs2(buf)
    return nothing
end


function evolve(p, t_array, states_track, N)
    nt = length(t_array)
    ntrack = length(states_track)

    # initialize buffers and matrices
    Hinit = zeros(ComplexF64, N, N)
    H = similar(Hinit)
    buffer = similar(Hinit)
    Hrot = similar(Hinit)
    Vrot = similar(Hinit)
    C = similar(Hinit)
    Vrefinit = similar(Hinit)
    Vref = similar(Hinit)
    tmp_NN  = similar(H)                       # N×N scratch
    tmp_Nk  = zeros(ComplexF64, ntrack, N)     # N×ntrack scratch
    V = similar(Hinit)
    U = similar(Hinit)
    Udt    = similar(Hinit)
    phase_vec   = zeros(ComplexF64, N)
    Vsort = similar(Hinit)                # sorted eigenvectors
    Esort = zeros(Float64, N)             # sorted eigenvalues

    ψ      = zeros(ComplexF64, N, ntrack)      # current kets
    ψ_tmp  = similar(ψ)

    # ── data containers you want to return / analyse later ──
    ψt     = Array{ComplexF64,3}(undef, N, ntrack, nt)
    Et     = Array{Float64,2}(undef, N, nt)
    Pt     = Array{Float64,3}(undef, ntrack, N, nt)

    Ω0, ω0, δ0, vz, z0 = p
    Ez = Ez_interp(z0 + vz * t_array[1])
    hamiltonian_full_nocoupling!(Hinit, Ez)

    copyto!(buffer, Hinit)
    Eref, _ = LinearAlgebra.LAPACK.syev!('V', 'U', buffer)
    copyto!(Vref, buffer)
    copyto!(Vrefinit, buffer)

    ψ .= @view Vref[:, states_track]

    detuning = zeros(Float64, N)
    @views detuning[5:16] .= -(ω0 + δ0)

    ψt[:, :, 1] .= ψ
    Et[:, 1]    .= Eref
    calculate_probabilities!(@view(Pt[:, :, 1]), ψ, Vref, tmp_Nk)

    for i in 2:length(t_array)
        dt = t_array[i] - t_array[i-1]
        t = t_array[i]

        z = z0 + vz * t
        Ez = Ez_interp(z)

        hamiltonian_full_nocoupling!(H, Ez)
        Ωval = Ω0/2 * gaussian_peak(z0 + vz * t_array[i], zμ0, σμ)
        coupling_full!(C, Ωval)

        copyto!(buffer, H)
        D, _ = LinearAlgebra.LAPACK.syev!('V', 'U', buffer)
        copyto!(V, buffer)

        reorder_evecs!(Vsort, Esort, V, D, Vref)

        # D is already sorted in ascending order
        H .+= C

        apply_transform!(Hrot, H, V, buffer)
        Hrot .+= diagm(detuning)

        Drot, _ = LinearAlgebra.LAPACK.syev!('V', 'U', Hrot)
        copyto!(Vrot, Hrot)

        # time-evolution operator Udt
        mul!(U, V, Vrot)
        @. phase_vec = cis(-Drot * dt)
        mul!(tmp_NN, U, Diagonal(phase_vec))
        mul!(Udt, tmp_NN, U')

        # advance ψ safely:  ψ ← Udt * ψ
        mul!(ψ_tmp, Udt, ψ)                     # no aliasing (N×ntrack)
        copyto!(ψ, ψ_tmp)

        ψt[:, :, i] .= ψ
        Et[:, i] .= Esort
        calculate_probabilities!(@view(Pt[:, :, i]), ψ, Vsort, tmp_Nk)

        copyto!(Vref, Vsort)
    end
    return ψt, Et, Pt
end

const Ez_interp = make_Ez_interp(field_path)

const σμ = 1.078e-2
const zμ0 = 0.0
const zμ1 = 25.4e-3 * 1.125
const Γ = 2π * 1.56e6

Ω0 = 1e-1 * Γ
ω0 = 83817990535.81007
δ0 = 0.0
vz = 184
z0 = -0.25
zstop = 0.2
tmax = (zstop - z0) / vz
N = 36
Δt = 1e-7
t_array = LinRange(0.0, tmax, 10001)
states_track = [1]

p = (Ω0, ω0, δ0, vz, z0)

@time ψt, Et, Pt = evolve(p, t_array, states_track, N);

plot(t_array*vz .+ z0, Pt[1,1:16,:]')

argmax(Pt[1,:,1]), argmax(Pt[1,:,end])

using LinearAlgebra
using Plots
using ProgressMeter

include("electric_field.jl")
# include("J01_J12_spa_backgroundfunctions.jl")
include("julia_functions.jl")

field_path = "c:/Users/Olivier/Anaconda3/envs/centrex-eql-testing/Lib/site-packages/state_prep/electric_fields/Electric field components vs z-position_SPA_ExpeVer.csv"
# field_path = "c:/Users/ogras/anaconda3/envs/centrex-eql/Lib/site-packages/state_prep/electric_fields/Electric field components vs z-position_SPA_ExpeVer.csv"


function reorder_evecs!(
    V_out::AbstractMatrix{<:ComplexF64},
    E_out::AbstractVector{<:Real},
    V_in ::AbstractMatrix{<:ComplexF64},
    E_in ::AbstractVector{<:Real},
    V_ref::AbstractMatrix{<:ComplexF64},
    overlap::AbstractMatrix{<:Real},
    workspace_complex::AbstractMatrix{<:ComplexF64},
)
    # 1. Absolute overlap between every eigenvector in V_in and every reference vector
    mul!(workspace_complex, V_in', V_ref)
    overlap .= abs.(workspace_complex)

    # 2. For each eigenvector (row), find the reference column with maximum overlap
    best_ref = map(argmax, eachrow(overlap))     # vector length n_in

    # 3. Sort eigenvectors by that reference-column index
    perm     = sortperm(best_ref)                # matches Python np.argsort(…)

    # if any(perm .!= eachindex(perm))
    #     println("Re-ordering eigenvectors with permutation: ", perm)
    # end

    # 4. Reorder into the provided output buffers (buffers must be distinct from inputs)
    V_out .= @view V_in[:, perm]
    E_out .= @view E_in[perm]
    return nothing
end

@inline function calculate_probabilities!(
    out::AbstractMatrix,            # ntrack × N
    ψ::AbstractMatrix,             # N × ntrack
    ϕ::AbstractMatrix,             # N × N
    buf::AbstractMatrix)           # ntrack × N
    # buf = ψ' * ϕ   →  (ntrack × N)
    mul!(buf, ψ', ϕ)

    # element-wise |·|², in place
    @. out = abs2(buf)
    return nothing
end

function evolve(p, t_array, states_track, Ez_interp, N)
    Ω0, Ω1, ω0, ω1, δ0, δ1, vz, z0 = p
    nt     = length(t_array)
    ntrack = length(states_track)

    # Helpers for allocations
    similar_c() = zeros(ComplexF64, N, N)
    similar_r() = zeros(Float64,   N, N)

    # Matrices
    H            = similar_c()      # Stark (field only)
    C            = similar_c()      # Couplings (bare basis)
    H_total      = similar_c()      # Full bare Hamiltonian
    H_dressed_S  = similar_c()      # Full Hamiltonian in Stark basis
    buffer_c     = similar_c()
    buffer_r     = similar_r()
    Vsort        = similar_c()

    # Bases
    V_S_prev = similar_c()
    V_S      = similar_c()
    V_D_prev = similar_c()
    V_D      = similar_c()
    W_dressed = similar_c()         # dressed eigenvectors (in Stark basis)

    # Overlap and phases
    O_overlap  = similar_c()
    phases_i   = zeros(ComplexF64, N)
    phases_ip1 = zeros(ComplexF64, N)

    # Eigenvalues
    D_S_prev = zeros(Float64, N)
    D_S      = zeros(Float64, N)
    D_D_prev = zeros(Float64, N)
    D_D      = zeros(Float64, N)

    # Coefficients and states
    c      = zeros(ComplexF64, N, ntrack)   # dressed basis coefficients
    ψ      = zeros(ComplexF64, N, ntrack)
    ψ_tmp  = zeros(ComplexF64, N, ntrack)
    tmp_Nk = zeros(ComplexF64, ntrack, N)   # for probability helper

    # Outputs
    ψt = Array{ComplexF64,3}(undef, N, ntrack, nt)
    Et = Array{Float64,2}(undef, N, nt)
    Pt = Array{Float64,3}(undef, ntrack, N, nt)

    # ---------- t0 ----------
    t0 = t_array[1]
    z  = z0 + vz * t0
    Ez = Ez_interp(z)

    # Stark Hamiltonian
    hamiltonian_full_nocoupling!(H, Ez)
    copyto!(buffer_c, H)
    D_S_prev, _ = LAPACK.syev!('V','U', buffer_c)
    copyto!(V_S_prev, buffer_c)

    # Couplings
    Ωval0 = Ω0/2 * gaussian_peak(z, zμ0, σμ)
    Ωval1 = Ω1/2 * gaussian_peak(z, zμ1, σμ)
    coupling_full!(C, Ωval0, Ωval1)

    # Total bare Hamiltonian
    H_total .= H .+ C

    # Transform to Stark basis
    apply_transform!(H_dressed_S, H_total, V_S_prev, buffer_c)

    # Detunings (acting in Stark basis)
    detuning!(H_dressed_S, δ0, δ1, ω0, ω1)

    # Dressed diagonalization (in Stark basis)
    copyto!(buffer_c, H_dressed_S)
    D_D_prev, _ = LAPACK.syev!('V','U', buffer_c)
    copyto!(W_dressed, buffer_c)

    # Bare dressed eigenvectors
    mul!(V_D_prev, V_S_prev, W_dressed)

    # Initial coefficients: start in chosen dressed eigenvectors
    ψ .= @view V_D_prev[:, states_track]
    c .= 0
    @inbounds for (j, st) in enumerate(states_track)
        c[st, j] = 1
    end

    ψt[:,:,1] .= ψ
    Et[:,1]    .= D_D_prev
    calculate_probabilities!(@view(Pt[:,:,1]), ψ, V_D_prev, tmp_Nk)

    # ---------- Time loop ----------
    @inbounds for step in 2:nt
        t_prev = t_array[step-1]
        t_cur  = t_array[step]
        dt     = t_cur - t_prev
        z      = z0 + vz * t_cur
        Ez     = Ez_interp(z)

        # Stark part
        hamiltonian_full_nocoupling!(H, Ez)
        copyto!(buffer_c, H)
        D_S_raw, _ = LAPACK.syev!('V','U', buffer_c)
        copyto!(V_S, buffer_c)

        # Single reorder (Stark) relative to previous Stark basis
        reorder_evecs!(Vsort, D_S, V_S, D_S_raw, V_S_prev, buffer_r, buffer_c)
        V_S .= Vsort
        D_S .= D_S

        # Couplings
        Ωval0 = Ω0/2 * gaussian_peak(z, zμ0, σμ)
        Ωval1 = Ω1/2 * gaussian_peak(z, zμ1, σμ)
        coupling_full!(C, Ωval0, Ωval1)

        H_total .= H .+ C

        # Transform full Hamiltonian into the (reordered) Stark basis
        apply_transform!(H_dressed_S, H_total, V_S, buffer_c)
        detuning!(H_dressed_S, δ0, δ1, ω0, ω1)

        # Dressed diagonalization in Stark basis
        copyto!(buffer_c, H_dressed_S)
        D_D_raw, _ = LAPACK.syev!('V','U', buffer_c)
        copyto!(W_dressed, buffer_c)

        # Form dressed eigenvectors (bare basis)
        mul!(V_D, V_S, W_dressed)
        D_D .= D_D_raw   # adopt ordering as produced (no reorder on dressed)

        # Overlap dressed bases and phase gauge
        mul!(O_overlap, V_D_prev', V_D)   # O = V_D_prev† V_D
        @inbounds for k in 1:N
            zkk = O_overlap[k,k]
            if zkk != 0
                ph = zkk / abs(zkk)
                V_D[:,k] .*= conj(ph)
                # adjust row k of O to reflect phase change:
                @inbounds for j in 1:N
                    O_overlap[k,j] *= ph
                end
                O_overlap[k,k] = abs(zkk)
            end
        end

        # Half step phases
        @inbounds for k in 1:N
            phases_i[k]   = ComplexF64(cos(-D_D_prev[k]*dt/2), sin(-D_D_prev[k]*dt/2))
            phases_ip1[k] = ComplexF64(cos(-D_D[k]     *dt/2), sin(-D_D[k]     *dt/2))
        end

        # Strang propagation
        # First half
        for j in 1:ntrack
            @inbounds for k in 1:N
                c[k,j] *= phases_i[k]
            end
        end
        # Rotate coefficients to new dressed basis: c' = O† c
        mul!(ψ_tmp, O_overlap', c)
        c .= ψ_tmp
        # Second half
        for j in 1:ntrack
            @inbounds for k in 1:N
                c[k,j] *= phases_ip1[k]
            end
        end

        # Reconstruct ψ = V_D * c
        mul!(ψ, V_D, c)

        ψt[:,:,step] .= ψ
        Et[:,step]   .= D_D
        calculate_probabilities!(@view(Pt[:,:,step]), ψ, V_D, tmp_Nk)

        # Advance previous bases
        V_S_prev .= V_S
        D_S_prev .= D_S
        V_D_prev .= V_D
        D_D_prev .= D_D
    end

    return ψt, Et, Pt
end

const Ez_interp = make_Ez_interp(field_path)

const σμ = 1.078e-2
const zμ0 = 0.0
const zμ1 = 25.4e-3 * 1.125
const Γ = 2π * 1.56e6

Ω0 = 3e-1 * Γ
Ω1 = 2e-1 * Γ
ω0 = 83817989701.69382
ω1 = 167564827658.9896
δ0 = 0.0
δ1 = 0.0
vz = 184
z0 = -0.25
zstop = 0.2
tmax = (zstop - z0) / vz
N = 64
t_array = LinRange(0.0, tmax, 6001)
states_track = [1]

p = (Ω0, Ω1, ω0, ω1, δ0, δ1, vz, z0)

ψt, Et, Pt = evolve(p, t_array, states_track, Ez_interp, N);

@time ψt, Et, Pt = evolve(p, t_array, states_track, Ez_interp, N);

plot(t_array*vz .+ z0, Pt[1,1:36,:]')

argmax(Pt[1,:,1]), argmax(Pt[1,:,end])

using SIMD
using LinearAlgebra
using DifferentialEquations
using CSV
using DataFrames
using Interpolations
using MKL

include("julia_functions.jl")
include("hamiltonian.jl")
include("couplings.jl")

efield_path = "c:/Users/Olivier/Anaconda3/envs/centrex-eql-testing/Lib/site-packages/state_prep/electric_fields/Electric field components vs z-position_SPA_ExpeVer.csv"
# efield_path = "c:/Users/ogras/anaconda3/envs/centrex-eql/Lib/site-packages/state_prep/electric_fields/Electric field components vs z-position_SPA_ExpeVer.csv"


const σμ = 1.078e-2
const zμ0 = 0.0
const zμ1 = 25.4e-3 * 1.125

function make_Ez_interp(path::AbstractString)
    # 1) load data
    df = CSV.read(path, DataFrame)

    # 2) extract & convert with floating‐point division
    x = df[!, "Distance-250mm [mm]"] ./ 1000.0   # mm → m
    y = df[!, "Ez []"] ./ 100.0     # raw → your unit

    # 3) sanity‐checks for uniform spacing
    @assert length(x) ≥ 2 "Need at least two points for interpolation"
    Δx = x[2] - x[1]
    @assert Δx != 0 "Δx is zero—did you accidentally use .÷ instead of ./?"
    @assert all(abs.(diff(x) .- Δx) .< 1e-8) "x must be uniformly spaced"

    # 4) build & scale a cubic B-spline
    itp = interpolate(y, BSpline(Cubic(Line(OnGrid()))))
    sitp = scale(itp, x[1]:Δx:x[end])

    # 5) wrap to fill with 0.0 outside the domain
    return extrapolate(sitp, 0.0)
end

const Ez_interp = make_Ez_interp(efield_path)

Γ = 2π*1.56e6
Ω0 = 1e-1*Γ
δ0 = 5.26e6 * 2π
vz = 184
z0 = -0.25
zstop = 0.2
tmax = (zstop - z0) / vz
N = 16
diag_idxs = [i + (i - 1) * N for i in 1:N]

u0 = zeros(ComplexF64, N, N)
u0[1,1] = 1.0 + 0.0im

const H = zeros(ComplexF64, size(u0))
const buffer = zeros(ComplexF64, size(u0))


function lindblad!(du, u, p, t)
    Ω0, δ0, vz, z0 = p

    z = vz * t + z0

    Ez = Ez_interp(z0 + vz * t)

    Ω0val = Ω0*gaussian_peak(z, zμ0, σμ)
    hamiltonian!(H, Ez, Ω0val, δ0)
    commutator_mat!(du, H, u)
    nothing
end


p = (Ω0, δ0, vz, z0)
prob = ODEProblem(
    lindblad!,
    u0,
    (0.0, tmax),
    p,
);

@time sol = solve(prob, Tsit5(), reltol=1e-5, abstol=1e-7, save_idxs=diag_idxs, dtmax=1e-6);


pop = hcat(real(sol.u)...);


function prob_func(prob, i, repeat)
    p = (rabis[i], δ0, vz, z0)
    remake(prob, p=p)
end

function prob_func(prob, i, repeat)
    p = (Ω0, detunings[i], vz, z0)
    remake(prob, p=p)
end

detunings = (-6:0.25:10.0) .+ 5.25
detunings *= 2π*1e6

ens_prob = EnsembleProblem(prob, prob_func=prob_func);
@time sol = solve(
    ens_prob,
    Tsit5(),
    EnsembleSerial(),
    trajectories=length(detunings),
    save_idxs=diag_idxs,
    save_start=false,
    save_everystep=false,
    reltol=1e-5,
    abstol=1e-7,
);

pop = hcat([real(sol[i].u[1]) for i in 1:length(sol)]...);
